{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
osCommerce Product Manager for Windows (oscpmwin).
Copyright 2003,2004,2005 by Mario A. Valdez-Ramirez.

You can contact Mario A. Valdez-Ramirez
by email at mario@mariovaldez.org or paper mail at
Olmos 809, San Nicolas, NL. 66495, Mexico.

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or (at
your option) any later version.

This program is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
UNIT FreeImage;

INTERFACE

USES Windows;

{$Z4}

CONST
  JPEG_DEFAULT = 0;
  JPEG_FAST = 1;
  JPEG_ACCURATE = 2;
  JPEG_QUALITYSUPERB = $80;
  JPEG_QUALITYGOOD = $100;
  JPEG_QUALITYNORMAL = $200;
  JPEG_QUALITYAVERAGE = $400;
  JPEG_QUALITYBAD = $800;


TYPE
  FIBITMAPDATA = RECORD
                   data : POINTER;
                 END;
  FIBITMAP = ^FIBITMAPDATA;
  FREE_IMAGE_FORMAT = (FIF_UNKNOWN = -1, FIF_BMP = 0, FIF_JPEG = 2, FIF_PCX = 10, FIF_PNG = 13,
                       FIF_TARGA = 17, FIF_TIFF = 18, FIF_WBMP = 19, FIF_PSD = 20, FIF_XBM = 22,
                       FIF_XPM = 23, FIF_GIF = 25);
  FREE_IMAGE_QUANTIZE = (FIQ_WUQUANT = 0, FIQ_NNQUANT = 1);
  FREE_IMAGE_FILTER = (FILTER_BOX  = 0, FILTER_BICUBIC = 1, FILTER_BILINEAR = 2,
                       FILTER_BSPLINE = 3, FILTER_CATMULLROM = 4, FILTER_LANCZOS3 = 5);


FUNCTION FreeImage_Allocate (width, height, bpp : LONGINT; red_mask : CARDINAL = 0; green_mask : CARDINAL = 0; blue_mask : CARDINAL = 0) : FIBITMAP;
STDCALL; EXTERNAL 'FreeImage.dll' name '_FreeImage_Allocate@24';

PROCEDURE FreeImage_Unload (dib : FIBITMAP);
STDCALL; EXTERNAL 'FreeImage.dll' name '_FreeImage_Unload@4';

FUNCTION FreeImage_Load (fif : FREE_IMAGE_FORMAT; filename : PCHAR; flags : LONGINT = 0) : FIBITMAP;
STDCALL; EXTERNAL 'FreeImage.dll' name '_FreeImage_Load@12';

FUNCTION FreeImage_Save (fif : FREE_IMAGE_FORMAT; dib : FIBITMAP; filename : PCHAR; flags : LONGINT = 0) : BOOLEAN;
STDCALL; EXTERNAL 'FreeImage.dll' name '_FreeImage_Save@16';

FUNCTION FreeImage_GetFileType (filename : PCHAR; size : LONGINT) : FREE_IMAGE_FORMAT;
STDCALL; EXTERNAL 'FreeImage.dll' name '_FreeImage_GetFileType@8';

PROCEDURE FreeImage_SetPixelColor (dib : FIBITMAP; x, y : LONGINT; value : PRGBQUAD);
STDCALL; EXTERNAL 'FreeImage.dll' name '_FreeImage_SetPixelColor@16';

FUNCTION FreeImage_GetWidth (dib : FIBITMAP) : CARDINAL;
STDCALL; EXTERNAL 'FreeImage.dll' name '_FreeImage_GetWidth@4';

FUNCTION FreeImage_GetHeight (dib : FIBITMAP) : CARDINAL;
STDCALL; EXTERNAL 'FreeImage.dll' name '_FreeImage_GetHeight@4';

PROCEDURE FreeImage_SetBackgroundColor (dib : FIBITMAP; value : PRGBQUAD);
STDCALL; EXTERNAL 'FreeImage.dll' name '_FreeImage_SetBackgroundColor@8';

FUNCTION FreeImage_ConvertTo8Bits (dib : FIBITMAP) : FIBITMAP;
STDCALL; EXTERNAL 'FreeImage.dll' name '_FreeImage_ConvertTo8Bits@4';

FUNCTION FreeImage_ConvertTo24Bits (dib : FIBITMAP) : FIBITMAP;
STDCALL; EXTERNAL 'FreeImage.dll' name '_FreeImage_ConvertTo24Bits@4';

FUNCTION FreeImage_ConvertTo32Bits (dib : FIBITMAP) : FIBITMAP;
STDCALL; EXTERNAL 'FreeImage.dll' name '_FreeImage_ConvertTo32Bits@4';

FUNCTION FreeImage_ColorQuantize (dib : FIBITMAP; quantize : FREE_IMAGE_QUANTIZE) : FIBITMAP;
STDCALL; EXTERNAL 'FreeImage.dll' name '_FreeImage_ColorQuantize@8';

FUNCTION FreeImage_Rescale (dib : FIBITMAP; dst_width, dst_height : LONGINT; filter : FREE_IMAGE_FILTER) : FIBITMAP;
STDCALL; EXTERNAL 'FreeImage.dll' name '_FreeImage_Rescale@16';

FUNCTION FreeImage_Copy (dib : FIBITMAP; left, top, right, bottom : LONGINT) : FIBITMAP;
STDCALL; EXTERNAL 'FreeImage.dll' name '_FreeImage_Copy@20';

FUNCTION FreeImage_Paste (dst, src : FIBITMAP; left, top, alpha : LONGINT) : BOOLEAN;
STDCALL; EXTERNAL 'FreeImage.dll' name '_FreeImage_Paste@20';

{$Z1}

IMPLEMENTATION

END.


